//+------------------------------------------------------------------+
//|                                                  Cams_Bounce.mq4 |
//|                                           kris.pivo[at]gmail.com |
//|                                       Indicator for Interbank FX |
//+------------------------------------------------------------------+
#property copyright " Kris, 2008"                                 //|
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 Red 
#property indicator_color2 C'80,80,80'
#property indicator_color3 C'80,80,80'
#property indicator_color4 C'80,80,80'
#property indicator_color5 C'80,80,80'
#property indicator_color6 LimeGreen

//Input Params
extern string PivotStart = "22:00";
extern string PivotEnd   = "22:00";
extern string Midnight   = "00:00";

double Buffer0[]; // Cam H3
double Buffer1[]; // Cam H2
double Buffer2[]; // Cam H1
double Buffer3[]; // Cam L1
double Buffer4[]; // Cam L2
double Buffer5[]; // Cam L3

double LastHigh,LastLow,LastClose;
double CamH6, CamH5, CamH4, CamH3, CamH2, CamH1, CamL1, CamL2, CamL3, CamL4, CamL5, CamL6;

int OpenBar;
    
int init()
{  SetIndexStyle(0,DRAW_LINE, STYLE_SOLID, 1);
   SetIndexBuffer(0,Buffer0);
   SetIndexLabel(0,"Cam H3");

   SetIndexStyle(1,DRAW_LINE, STYLE_DOT, 1);
   SetIndexBuffer(1,Buffer1);
   SetIndexLabel(1,"Cam H2");

   SetIndexStyle(2,DRAW_LINE, STYLE_DOT, 1);
   SetIndexBuffer(2,Buffer2);
   SetIndexLabel(2,"Cam H1");
   
   SetIndexStyle(3,DRAW_LINE, STYLE_DOT, 1);
   SetIndexBuffer(3,Buffer3);
   SetIndexLabel(3,"Cam L1");
   
   SetIndexStyle(4,DRAW_LINE, STYLE_DOT, 1);
   SetIndexBuffer(4,Buffer4);
   SetIndexLabel(4,"Cam L2");
   
   SetIndexStyle(5,DRAW_LINE, STYLE_SOLID, 1);
   SetIndexBuffer(5,Buffer5);
   SetIndexLabel(5,"Cam L3");
   
   return(0); }

int deinit()
{ return(0); }

int start()
{  string BarTime="", LastBarTime="";         
   string BarDay="", LastBarDay="";
   int CloseBar;
          
   for(int i=Bars; i>=0; i--)
   {  BarTime = TimeToStr(Time[i], TIME_MINUTES);
      LastBarTime = TimeToStr(Time[i+1], TIME_MINUTES);
      BarDay = TimeToStr(Time[i],TIME_DATE);
      LastBarDay = TimeToStr(Time[i+1],TIME_DATE); 
      
      //need to handle if pivotrangestart/end is 00:00
      if ((PivotEnd == "00:00" && BarTime>=PivotEnd && BarDay>LastBarDay) || (BarTime>=PivotEnd && LastBarTime<PivotEnd))
      {  CloseBar = i + 1;
         
         if (OpenBar>0)
         {  calculatePivotRangeValues(OpenBar, CloseBar);  }  }
      
      if ((PivotStart == "00:00" && BarTime>=PivotStart && BarDay>LastBarDay) || (BarTime>=PivotStart && LastBarTime<PivotStart))
      { OpenBar = i; }
      
      if (OpenBar>0)
      { drawIndicators(i);  } }
   return(0);}
void calculatePivotRangeValues(int openBar, int closeBar)
   {
   LastHigh  = High[Highest(NULL, 0, MODE_HIGH, (openBar - closeBar + 1), closeBar)];
   LastLow   = Low[Lowest(NULL, 0, MODE_LOW, (openBar - closeBar + 1), closeBar)];
   LastClose = Close[closeBar];
   
// CamH6 = LastClose + (LastHigh - LastLow);
// CamH5 = LastClose + (LastHigh - LastLow) * 3/4;
// CamH4 = LastClose + (LastHigh - LastLow) * 1/2;
	CamH3 = LastClose + (LastHigh - LastLow) * 1/4;
	CamH2 = LastClose + (LastHigh - LastLow) * 1/6;
	CamH1 = LastClose + (LastHigh - LastLow) * 1/16;
	CamL1 = LastClose - (LastHigh - LastLow) * 1/16;
	CamL2 = LastClose - (LastHigh - LastLow) * 1/6;
	CamL3 = LastClose - (LastHigh - LastLow) * 1/4;
//	CamL4 = LastClose - (LastHigh - LastLow) * 1/2;
// CamL5 = LastClose - (LastHigh - LastLow) * 3/4;
//	CamL6 = LastClose - (LastHigh - LastLow);
   }

void drawIndicators(int curBar)
{
   Buffer0[curBar]=CamH3;
   Buffer1[curBar]=CamH2;
   Buffer2[curBar]=CamH1;
   Buffer3[curBar]=CamL1;
   Buffer4[curBar]=CamL2;
   Buffer5[curBar]=CamL3;
}
//+-----------------------------------------------------------------------------------------+
//|                                         THE END                                         |
//+-----------------------------------------------------------------------------------------+